package controllers

import (
	"devel.mephi.ru/dyokunev/cps-models"
	"github.com/revel/revel"
	"time"
)

type Events struct {
	Controller
}

func (c Events) Index(event models.Event, optimizeOutput bool, startDate, endDate time.Time) revel.Result {
	if r := c.Init(); r != nil {
		return r
	}

	if (models.Event{}) == event && (time.Time{}) == startDate && (time.Time{}) == endDate {
		return c.Error("Empty filters")
	}

	scope := c.EventSQL.Order("dtDate", "ASC")

	if (models.Event{}) != event {
		scope = scope.Where(event)
	}
	if (time.Time{}) != startDate {
		scope = scope.Where("dtDate >= ?", startDate)
	}
	if (time.Time{}) != endDate {
		scope = scope.Where("dtDate < ?", endDate)
	}

	events, err := scope.Select()
	if r := c.ConsiderErr(err); r != nil {
		return r
	}

	if optimizeOutput {
		/*for idx, _ := range events[idx] {
			event := &events[idx]

			event.LogId = 0
		}*/
	}

	return c.Render(events)
}
