package controllers

import (
	renderModels "devel.mephi.ru/dyokunev/cps-models/for_render"
	asuModels "devel.mephi.ru/dyokunev/go-asu-models"
	"github.com/revel/revel"
	"time"
)

type TimesheetRows struct {
	Controller
}

func (c TimesheetRows) Index(timesheetRow asuModels.TimesheetRow, startDate, endDate time.Time, prepareFormular bool) revel.Result {
	if r := c.Init(); r != nil {
		return r
	}

	scope := c.TimesheetRowSQL

	if !timesheetRow.IsEqualsTo(asuModels.TimesheetRow{}) {
		scope = scope.Where(timesheetRow)
	}
	if (time.Time{}) != startDate {
		scope = scope.Where("ADate >= ?", startDate)
	}
	if (time.Time{}) != endDate {
		scope = scope.Where("ADate < ?", endDate)
	}

	timesheetRows, err := scope.Select("is_manually_removed = 0") //"StaffCardId IN (SELECT StfCardId FROM formular)")
	if r := c.ConsiderErr(err); r != nil {
		return r
	}

	if prepareFormular {
		asuModels.TimesheetRows(timesheetRows).PrepareFormulars(true)
	}

	return c.Render(renderModels.NewTimesheetRows(timesheetRows))
}
